<?php
/**
 * @package	Website Blacklist Monitor
 * @copyright	Copyright (C) 2014 SiteGuarding.com. All rights reserved.
 * @license	GNU General Public License version 2 or later
 */
defined( '_JEXEC' ) or die; // No direct access

if (!defined('DIRSEP'))
{
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') define('DIRSEP', '\\');
	else define('DIRSEP', '/');
}

if (file_exists(dirname(__FILE__).DIRSEP.'plgsgwbm.php')) include_once(dirname(__FILE__).DIRSEP.'plgsgwbm.php');
if (file_exists(dirname(__FILE__).DIRSEP.'urlvoidapi.php')) include_once(dirname(__FILE__).DIRSEP.'urlvoidapi.php');

/**
 * Default Controller
 * @author SiteGuarding
 */
class BlacklistsController extends JControllerLegacy
{

	/**
	 * Method to display a view.
	 * @param bool $cachable
	 * @param array $urlparams
	 * @return JControllerLegacy
	 */
	function display( $cachable = false, $urlparams = array() )
	{
		$db = (JVERSION < 4) ? JFactory::getDBO() : JFactory::getContainer()->get('DatabaseDriver');
		$db->setQuery("SELECT data, date FROM #__blacklists WHERE id=1");
		$params = $db->loadAssoc();
		
		$data = array(
			'latest_scan_date' => $params['date'],
			'latest_results' => $params['data']
		);
		
		
		$session = JFactory::getSession();
		$session->set('data', $data);
			
		$this->default_view = 'blacklistss';
		parent::display( $cachable, $urlparams );
		return $this;
	}

	/**
	 * Call AJAX method
	 * @throws Exception
	 */
	public function getAjax()
	{
		$input = JFactory::getApplication()->input;
		$model = $this->getModel( 'ajax' );
		$action = $input->getCmd( 'action' );
		$reflection = new ReflectionClass( $model );
		$methods = $reflection->getMethods( ReflectionMethod::IS_PUBLIC );
		$methodList = array();
		foreach ( $methods as $method ) {
			$methodList[] = $method->name;
		}
		if ( in_array( $action, $methodList ) ) {
			$model->$action();
		}
		exit;
	}

	 
	public function scan()
	{
		$params = JComponentHelper::getParams('com_blacklists');
		$domain = PLGSGWBM::PrepareDomain(JURI::root());
		
		$data = array(
			'latest_scan_date' => time(),
			'latest_results' => array()
		);
		
		
		if (PLGSGWBM::Scan_in_Google($domain) == "BL") $data['latest_results'][] = 'Google';
		if (PLGSGWBM::Scan_in_McAfee($domain) == "BL") $data['latest_results'][] = 'McAfee';
		if (PLGSGWBM::Scan_in_Norton($domain) == "BL") $data['latest_results'][] = 'Norton';
		
		$URLVoid_arr = PLGSGWBM::Scan_in_URLVoid($domain);
		if (count($URLVoid_arr))
		{
			foreach ($URLVoid_arr as $row)
			{
				$data['latest_results'][] = $row;
			}
		}
		
		
		$data['latest_results'] = serialize($data['latest_results']);
		
		$db = (JVERSION < 4) ? JFactory::getDBO() : JFactory::getContainer()->get('DatabaseDriver');
		$db->setQuery("UPDATE #__blacklists SET data = '{$data['latest_results']}', date = {$data['latest_scan_date']} WHERE id=1");
		$db->execute();

		
				$this->setRedirect(JRoute::_('index.php?option=com_blacklists'), false);
	}
	


	
	
}